
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _VERTEX_H_
#define _VERTEX_H_

#include "classes.h"

class vertex {
public:
	vertex(); ///< null constructor
	vertex(const c3ga::tangentBivector &ptAtt, const c3ga::normalizedFlatPoint2D &tex_pt); ///< constructor; sets all data of the vertex
	vertex(const vertex &v); ///< copy constructor
	~vertex(); ///< destructor

	vertex &operator=(const vertex &v); ///< copy operator

	/// retrieves m_pt_att
	inline const c3ga::tangentBivector &get_pt_att() const {return m_pt_att;}

	/// retrieves m_tex_pt
	inline const c3ga::normalizedFlatPoint2D &get_tex_pt() const {return m_tex_pt;}

	/// calls glVertex() for OpenGL rendering
	void glVertex() const;
	/// calls glNormal() for OpenGL rendering
	void glNormal() const;

private:
//	c3ga::normalizedPoint m_pt; ///< point in conformal model
//	c3ga::freeBivector  m_att; ///< local surface attitude 

	c3ga::tangentBivector m_pt_att; ///< contains point and local surface attitude

	c3ga::normalizedFlatPoint2D m_tex_pt; ///< index into texture 
};

#endif /* _VERTEX_H_ */

