#include "p3la.h"

void p3la_vec::print(const char *text, const char *fmt /* = NULL */) const {
	char buf[1024];
	if (text) printf("%s", text);
	if (fmt == NULL) fmt = "%2.2f";

	sprintf(buf, "x: %s y: %s z: %s\n", fmt, fmt, fmt);
	printf(buf, x, y, z);
}

void p3la_point::print(const char *text, const char *fmt /* = NULL */) const {
	char buf[1024];
	if (text) printf("%s", text);
	if (fmt == NULL) fmt = "%2.2f";

	sprintf(buf, "x: %s y: %s z: %s\n", fmt, fmt, fmt);
	printf(buf, x / w, y / w, z / w);
}

void p3la_line::print(const char *text, const char *fmt /* = NULL */) const {
	char buf[1024];
	if (text) printf("%s", text);
	if (fmt == NULL) fmt = "%2.2f";

	sprintf(buf, "yz: %s zx: %s xy: %s xw: %s yw: %s zw: %s\n", fmt, fmt, fmt, fmt, fmt, fmt);
	printf(buf, yz, zx, xy, xw, yw, zw);
}

void p3la_tm::print(const char *text, const char *fmt /* = NULL */) const {
	char buf[1024];
	if (text) printf("%s", text);
	if (fmt == NULL) fmt = "%2.2f";

	sprintf(buf, "%s %s %s %s\n", fmt, fmt, fmt, fmt);
	printf(buf, m11, m12, m13, m14);
	printf(buf, m21, m22, m23, m24);
	printf(buf, m31, m32, m33, m34);
	printf(buf, m41, m42, m43, m44);
}


void p3la_plane::print(const char *text, const char *fmt /* = NULL */) const {
	char buf[1024];
	if (text) printf("%s", text);
	if (fmt == NULL) fmt = "%2.2f";

	sprintf(buf, "x: %s y: %s z: %s d: %s\n", fmt, fmt, fmt, fmt);
	printf(buf, x, y, z, d);
}


