
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _PNGFE_H_
#define _PNGFE_H_

#include <string>

/*
PNG front end

This header provides simple ways to load and save .png files.
*/

/*
Possible flags for loadPNG()
*/
#define PNG_NO_ALLOC 0x01		// don't allocate memory for pixels; application will do that

/*
save_png():
filename: name of the file where the data should be written to
pixels:	array of pixels (format: RGBRGB etc etc, topdown, left-to-right, width x height)

throws std::string on failure
*/
void save_png(std::string filename, const unsigned char *pixels, int width, int height);

/*
load_png():
filename: name of the file where the data should be written to
pixels:	array of pixels (format: RGBRGB etc etc, topdown, left-to-right, width x height)

throws std::string on failure
*/
void load_png(std::string filename, unsigned char **pixels, int *width, int *height, int flags);

/*
load_png_ex(): loads PNG from memory
buf + bufLength: PNG file in memory
pixels:	array of pixels (format: RGBRGB etc etc, topdown, left-to-right, width x height)

throws std::string on failure
*/
void load_png_ex(const unsigned char *buf, int bufLength, unsigned char **pixels, int *width, int *height, int flags);

#endif /* _PNGFE_H_ */
